unit main;

{$mode objfpc}{$H+}

interface
{$ifdef win32}
  {$R ginttu.res}
{$endif}

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Menus, Windows;
  // "Windows" muss eingebunden werden, um auf die WinAPI
  // Befehle und Konstanten zugreifen zu knnen.
  // Siehe LoadIcon(hInstance,...).

type

  { TForm1 }

  TForm1 = class(TForm)
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    PopupMenu1: TPopupMenu;
    TrayIcon1: TTrayIcon;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure CanCloseQuery(Sender : TObject; var CanClose : boolean);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1;
  CanClose : boolean;
  

implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
const
     IDI_ICON1 = 101;
begin
     TrayIcon1.Icon.Handle:= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
     TrayIcon1.PopUpMenu := PopupMenu1;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  if Sender = Form1 then
  begin
       CloseAction := caNone;
       TrayIcon1.Visible:= True;
       Form1.Visible:= False;
  end
  else if Sender = MenuItem2 then
  begin
       CloseAction := caFree;
       Close;
  end;
end;

procedure TForm1.MenuItem1Click(Sender: TObject);
begin
  Form1.Visible := True;
  TrayIcon1.Visible := False;
end;

procedure TForm1.MenuItem2Click(Sender: TObject);
begin
     self.Tag := 1;
     Close;
end;

procedure TForm1.CanCloseQuery(Sender : TObject; var CanClose : boolean);
begin
if self.Tag <> 1 then
   CanClose := false;
end;
initialization
  {$I main.lrs}

end.

